/* NodeMenu.c generated by valac 0.43.4, the Vala compiler
 * generated from NodeMenu.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_NODE_MENU (node_menu_get_type ())
#define NODE_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_MENU, NodeMenu))
#define NODE_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_MENU, NodeMenuClass))
#define IS_NODE_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_MENU))
#define IS_NODE_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_MENU))
#define NODE_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_MENU, NodeMenuClass))

typedef struct _NodeMenu NodeMenu;
typedef struct _NodeMenuClass NodeMenuClass;
typedef struct _NodeMenuPrivate NodeMenuPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
enum  {
	NODE_MENU_0_PROPERTY,
	NODE_MENU_NUM_PROPERTIES
};
static GParamSpec* node_menu_properties[NODE_MENU_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_NODE_IMAGE (node_image_get_type ())
#define NODE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_IMAGE, NodeImage))
#define NODE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_IMAGE, NodeImageClass))
#define IS_NODE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_IMAGE))
#define IS_NODE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_IMAGE))
#define NODE_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_IMAGE, NodeImageClass))

typedef struct _NodeImage NodeImage;
typedef struct _NodeImageClass NodeImageClass;

#define TYPE_CONNECTIONS (connections_get_type ())
#define CONNECTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONNECTIONS, Connections))
#define CONNECTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONNECTIONS, ConnectionsClass))
#define IS_CONNECTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONNECTIONS))
#define IS_CONNECTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONNECTIONS))
#define CONNECTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONNECTIONS, ConnectionsClass))

typedef struct _Connections Connections;
typedef struct _ConnectionsClass ConnectionsClass;
#define _connections_unref0(var) ((var == NULL) ? NULL : (var = (connections_unref (var), NULL)))

struct _NodeMenu {
	GtkMenu parent_instance;
	NodeMenuPrivate * priv;
};

struct _NodeMenuClass {
	GtkMenuClass parent_class;
};

struct _NodeMenuPrivate {
	DrawArea* _da;
	GtkMenuItem* _copy;
	GtkMenuItem* _cut;
	GtkMenuItem* _paste;
	GtkMenuItem* _delete;
	GtkMenuItem* _edit;
	GtkMenuItem* _task;
	GtkMenuItem* _note;
	GtkMenuItem* _image;
	GtkMenuItem* _conn;
	GtkMenuItem* _fold;
	GtkMenuItem* _detach;
	GtkMenuItem* _root;
	GtkMenuItem* _child;
	GtkMenuItem* _sibling;
	GtkMenuItem* _selroot;
	GtkMenuItem* _selnext;
	GtkMenuItem* _selprev;
	GtkMenuItem* _selchild;
	GtkMenuItem* _selparent;
	GtkMenuItem* _selconn;
	GtkMenuItem* _center;
};

static gint NodeMenu_private_offset;
static gpointer node_menu_parent_class = NULL;

GType node_menu_get_type (void) G_GNUC_CONST;
GType draw_area_get_type (void) G_GNUC_CONST;
NodeMenu* node_menu_new (DrawArea* da,
                         GtkAccelGroup* accel_group);
NodeMenu* node_menu_construct (GType object_type,
                               DrawArea* da,
                               GtkAccelGroup* accel_group);
static void node_menu_copy (NodeMenu* self);
static void _node_menu_copy_gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
void utils_add_accel_label (GtkMenuItem* item,
                            guint key,
                            GdkModifierType mods);
static void node_menu_cut (NodeMenu* self);
static void _node_menu_cut_gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
static void node_menu_paste (NodeMenu* self);
static void _node_menu_paste_gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void node_menu_delete_node (NodeMenu* self);
static void _node_menu_delete_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self);
static void node_menu_edit_node (NodeMenu* self);
static void _node_menu_edit_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                  gpointer self);
static void node_menu_change_task (NodeMenu* self);
static void _node_menu_change_task_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self);
static void node_menu_change_note (NodeMenu* self);
static void _node_menu_change_note_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self);
static void node_menu_change_image (NodeMenu* self);
static void _node_menu_change_image_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                     gpointer self);
static void node_menu_add_connection (NodeMenu* self);
static void _node_menu_add_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self);
static void node_menu_fold_node (NodeMenu* self);
static void _node_menu_fold_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                  gpointer self);
static void node_menu_detach_node (NodeMenu* self);
static void _node_menu_detach_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self);
static void node_menu_add_root_node (NodeMenu* self);
static void _node_menu_add_root_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                      gpointer self);
static void node_menu_add_child_node (NodeMenu* self);
static void _node_menu_add_child_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self);
static void node_menu_add_sibling_node (NodeMenu* self);
static void _node_menu_add_sibling_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self);
static void node_menu_select_root_node (NodeMenu* self);
static void _node_menu_select_root_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self);
static void node_menu_select_next_sibling_node (NodeMenu* self);
static void _node_menu_select_next_sibling_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                 gpointer self);
static void node_menu_select_previous_sibling_node (NodeMenu* self);
static void _node_menu_select_previous_sibling_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                     gpointer self);
static void node_menu_select_child_node (NodeMenu* self);
static void _node_menu_select_child_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self);
static void node_menu_select_parent_node (NodeMenu* self);
static void _node_menu_select_parent_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                           gpointer self);
static void node_menu_select_connection (NodeMenu* self);
static void _node_menu_select_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self);
static void node_menu_center_current_node (NodeMenu* self);
static void _node_menu_center_current_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self);
static void node_menu_on_popup (NodeMenu* self);
static void _node_menu_on_popup_gtk_widget_show (GtkWidget* _sender,
                                          gpointer self);
static gboolean node_menu_node_is_task (NodeMenu* self);
GType node_get_type (void) G_GNUC_CONST;
Node* draw_area_get_current_node (DrawArea* self);
gboolean node_task_enabled (Node* self);
static gboolean node_menu_node_has_note (NodeMenu* self);
const gchar* node_get_note (Node* self);
static gboolean node_menu_node_has_image (NodeMenu* self);
gpointer node_image_ref (gpointer instance);
void node_image_unref (gpointer instance);
GParamSpec* param_spec_node_image (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_node_image (GValue* value,
                           gpointer v_object);
void value_take_node_image (GValue* value,
                            gpointer v_object);
gpointer value_get_node_image (const GValue* value);
GType node_image_get_type (void) G_GNUC_CONST;
NodeImage* node_get_image (Node* self);
static gboolean node_menu_node_foldable (NodeMenu* self);
gboolean node_is_leaf (Node* self);
static gboolean node_menu_node_is_folded (NodeMenu* self);
gboolean node_get_folded (Node* self);
gboolean draw_area_node_pasteable (DrawArea* self);
gpointer connections_ref (gpointer instance);
void connections_unref (gpointer instance);
GParamSpec* param_spec_connections (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_connections (GValue* value,
                            gpointer v_object);
void value_take_connections (GValue* value,
                             gpointer v_object);
gpointer value_get_connections (const GValue* value);
GType connections_get_type (void) G_GNUC_CONST;
Connections* draw_area_get_connections (DrawArea* self);
gboolean connections_get_hide (Connections* self);
gboolean draw_area_detachable (DrawArea* self);
gboolean draw_area_root_selectable (DrawArea* self);
gboolean draw_area_sibling_selectable (DrawArea* self);
gboolean draw_area_child_selectable (DrawArea* self);
gboolean draw_area_parent_selectable (DrawArea* self);
void draw_area_do_copy (DrawArea* self);
void draw_area_do_cut (DrawArea* self);
void draw_area_do_paste (DrawArea* self);
void draw_area_delete_node (DrawArea* self);
void draw_area_change_current_task (DrawArea* self,
                                    gboolean enable,
                                    gboolean done);
void draw_area_change_current_node_note (DrawArea* self,
                                         const gchar* note);
void draw_area_delete_current_image (DrawArea* self);
void draw_area_add_current_image (DrawArea* self);
void draw_area_start_connection (DrawArea* self,
                                 gboolean key);
void draw_area_change_current_fold (DrawArea* self,
                                    gboolean folded);
void draw_area_add_root_node (DrawArea* self);
void draw_area_add_child_node (DrawArea* self);
void draw_area_add_sibling_node (DrawArea* self);
void draw_area_detach (DrawArea* self);
void draw_area_select_root_node (DrawArea* self);
void draw_area_select_sibling_node (DrawArea* self,
                                    gint dir);
void draw_area_select_child_node (DrawArea* self);
void draw_area_select_parent_node (DrawArea* self);
void draw_area_select_attached_connection (DrawArea* self);
void draw_area_center_current_node (DrawArea* self);
static void node_menu_finalize (GObject * obj);

static inline gpointer
node_menu_get_instance_private (NodeMenu* self)
{
	return G_STRUCT_MEMBER_P (self, NodeMenu_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/NodeMenu.vala"
	return self ? g_object_ref (self) : NULL;
#line 290 "NodeMenu.c"
}

static void
_node_menu_copy_gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
#line 55 "../src/NodeMenu.vala"
	node_menu_copy ((NodeMenu*) self);
#line 299 "NodeMenu.c"
}

static void
_node_menu_cut_gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 59 "../src/NodeMenu.vala"
	node_menu_cut ((NodeMenu*) self);
#line 308 "NodeMenu.c"
}

static void
_node_menu_paste_gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 63 "../src/NodeMenu.vala"
	node_menu_paste ((NodeMenu*) self);
#line 317 "NodeMenu.c"
}

static void
_node_menu_delete_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                               gpointer self)
{
#line 67 "../src/NodeMenu.vala"
	node_menu_delete_node ((NodeMenu*) self);
#line 326 "NodeMenu.c"
}

static void
_node_menu_edit_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self)
{
#line 71 "../src/NodeMenu.vala"
	node_menu_edit_node ((NodeMenu*) self);
#line 335 "NodeMenu.c"
}

static void
_node_menu_change_task_gtk_menu_item_activate (GtkMenuItem* _sender,
                                               gpointer self)
{
#line 75 "../src/NodeMenu.vala"
	node_menu_change_task ((NodeMenu*) self);
#line 344 "NodeMenu.c"
}

static void
_node_menu_change_note_gtk_menu_item_activate (GtkMenuItem* _sender,
                                               gpointer self)
{
#line 78 "../src/NodeMenu.vala"
	node_menu_change_note ((NodeMenu*) self);
#line 353 "NodeMenu.c"
}

static void
_node_menu_change_image_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                gpointer self)
{
#line 81 "../src/NodeMenu.vala"
	node_menu_change_image ((NodeMenu*) self);
#line 362 "NodeMenu.c"
}

static void
_node_menu_add_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                  gpointer self)
{
#line 84 "../src/NodeMenu.vala"
	node_menu_add_connection ((NodeMenu*) self);
#line 371 "NodeMenu.c"
}

static void
_node_menu_fold_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self)
{
#line 88 "../src/NodeMenu.vala"
	node_menu_fold_node ((NodeMenu*) self);
#line 380 "NodeMenu.c"
}

static void
_node_menu_detach_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                               gpointer self)
{
#line 92 "../src/NodeMenu.vala"
	node_menu_detach_node ((NodeMenu*) self);
#line 389 "NodeMenu.c"
}

static void
_node_menu_add_root_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                 gpointer self)
{
#line 95 "../src/NodeMenu.vala"
	node_menu_add_root_node ((NodeMenu*) self);
#line 398 "NodeMenu.c"
}

static void
_node_menu_add_child_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                  gpointer self)
{
#line 98 "../src/NodeMenu.vala"
	node_menu_add_child_node ((NodeMenu*) self);
#line 407 "NodeMenu.c"
}

static void
_node_menu_add_sibling_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self)
{
#line 102 "../src/NodeMenu.vala"
	node_menu_add_sibling_node ((NodeMenu*) self);
#line 416 "NodeMenu.c"
}

static void
_node_menu_select_root_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self)
{
#line 110 "../src/NodeMenu.vala"
	node_menu_select_root_node ((NodeMenu*) self);
#line 425 "NodeMenu.c"
}

static void
_node_menu_select_next_sibling_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self)
{
#line 114 "../src/NodeMenu.vala"
	node_menu_select_next_sibling_node ((NodeMenu*) self);
#line 434 "NodeMenu.c"
}

static void
_node_menu_select_previous_sibling_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self)
{
#line 118 "../src/NodeMenu.vala"
	node_menu_select_previous_sibling_node ((NodeMenu*) self);
#line 443 "NodeMenu.c"
}

static void
_node_menu_select_child_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                     gpointer self)
{
#line 122 "../src/NodeMenu.vala"
	node_menu_select_child_node ((NodeMenu*) self);
#line 452 "NodeMenu.c"
}

static void
_node_menu_select_parent_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                      gpointer self)
{
#line 126 "../src/NodeMenu.vala"
	node_menu_select_parent_node ((NodeMenu*) self);
#line 461 "NodeMenu.c"
}

static void
_node_menu_select_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                     gpointer self)
{
#line 130 "../src/NodeMenu.vala"
	node_menu_select_connection ((NodeMenu*) self);
#line 470 "NodeMenu.c"
}

static void
_node_menu_center_current_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self)
{
#line 134 "../src/NodeMenu.vala"
	node_menu_center_current_node ((NodeMenu*) self);
#line 479 "NodeMenu.c"
}

static void
_node_menu_on_popup_gtk_widget_show (GtkWidget* _sender,
                                     gpointer self)
{
#line 172 "../src/NodeMenu.vala"
	node_menu_on_popup ((NodeMenu*) self);
#line 488 "NodeMenu.c"
}

NodeMenu*
node_menu_construct (GType object_type,
                     DrawArea* da,
                     GtkAccelGroup* accel_group)
{
	NodeMenu * self = NULL;
	DrawArea* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* _tmp2_;
	GtkMenuItem* _tmp3_;
	GtkMenuItem* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenuItem* _tmp10_;
	GtkMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenuItem* _tmp17_;
	GtkMenuItem* _tmp18_;
	GtkMenuItem* _tmp19_;
	GtkMenuItem* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenuItem* _tmp22_;
	GtkMenuItem* _tmp23_;
	GtkMenuItem* _tmp24_;
	GtkMenuItem* _tmp25_;
	GtkMenuItem* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkMenuItem* _tmp28_;
	GtkMenuItem* _tmp29_;
	GtkMenuItem* _tmp30_;
	GtkMenuItem* _tmp31_;
	GtkMenuItem* _tmp32_;
	GtkMenuItem* _tmp33_;
	GtkMenuItem* _tmp34_;
	GtkMenuItem* _tmp35_;
	GtkMenuItem* _tmp36_;
	GtkMenuItem* _tmp37_;
	GtkMenuItem* selnode = NULL;
	GtkMenuItem* _tmp38_;
	GtkMenu* selmenu = NULL;
	GtkMenu* _tmp39_;
	GtkMenuItem* _tmp40_;
	GtkMenuItem* _tmp41_;
	GtkMenuItem* _tmp42_;
	GtkMenuItem* _tmp43_;
	GtkMenuItem* _tmp44_;
	GtkMenuItem* _tmp45_;
	GtkMenuItem* _tmp46_;
	GtkMenuItem* _tmp47_;
	GtkMenuItem* _tmp48_;
	GtkMenuItem* _tmp49_;
	GtkMenuItem* _tmp50_;
	GtkMenuItem* _tmp51_;
	GtkMenuItem* _tmp52_;
	GtkMenuItem* _tmp53_;
	GtkMenuItem* _tmp54_;
	GtkMenuItem* _tmp55_;
	GtkMenuItem* _tmp56_;
	GtkMenuItem* _tmp57_;
	GtkMenuItem* _tmp58_;
	GtkMenuItem* _tmp59_;
	GtkMenuItem* _tmp60_;
	GtkMenuItem* _tmp61_;
	GtkMenuItem* _tmp62_;
	GtkMenuItem* _tmp63_;
	GtkMenuItem* _tmp64_;
	GtkSeparatorMenuItem* _tmp65_;
	GtkSeparatorMenuItem* _tmp66_;
	GtkMenuItem* _tmp67_;
	GtkMenuItem* _tmp68_;
	GtkMenuItem* _tmp69_;
	GtkMenuItem* _tmp70_;
	GtkMenuItem* _tmp71_;
	GtkMenuItem* _tmp72_;
	GtkSeparatorMenuItem* _tmp73_;
	GtkSeparatorMenuItem* _tmp74_;
	GtkMenuItem* _tmp75_;
	GtkMenuItem* _tmp76_;
	GtkMenuItem* _tmp77_;
	GtkSeparatorMenuItem* _tmp78_;
	GtkSeparatorMenuItem* _tmp79_;
	GtkMenuItem* _tmp80_;
	GtkSeparatorMenuItem* _tmp81_;
	GtkSeparatorMenuItem* _tmp82_;
	GtkMenuItem* _tmp83_;
	GtkMenuItem* _tmp84_;
	GtkMenuItem* _tmp85_;
	GtkMenuItem* _tmp86_;
	GtkMenuItem* _tmp87_;
	GtkMenuItem* _tmp88_;
	GtkSeparatorMenuItem* _tmp89_;
	GtkSeparatorMenuItem* _tmp90_;
	GtkMenuItem* _tmp91_;
#line 50 "../src/NodeMenu.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 50 "../src/NodeMenu.vala"
	g_return_val_if_fail (accel_group != NULL, NULL);
#line 50 "../src/NodeMenu.vala"
	self = (NodeMenu*) g_object_new (object_type, NULL);
#line 52 "../src/NodeMenu.vala"
	_tmp0_ = _g_object_ref0 (da);
#line 52 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_da);
#line 52 "../src/NodeMenu.vala"
	self->priv->_da = _tmp0_;
#line 54 "../src/NodeMenu.vala"
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Copy"));
#line 54 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp1_);
#line 54 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_copy);
#line 54 "../src/NodeMenu.vala"
	self->priv->_copy = _tmp1_;
#line 55 "../src/NodeMenu.vala"
	_tmp2_ = self->priv->_copy;
#line 55 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp2_, "activate", (GCallback) _node_menu_copy_gtk_menu_item_activate, self, 0);
#line 56 "../src/NodeMenu.vala"
	_tmp3_ = self->priv->_copy;
#line 56 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp3_, (guint) 'c', GDK_CONTROL_MASK);
#line 58 "../src/NodeMenu.vala"
	_tmp4_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Cut"));
#line 58 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp4_);
#line 58 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_cut);
#line 58 "../src/NodeMenu.vala"
	self->priv->_cut = _tmp4_;
#line 59 "../src/NodeMenu.vala"
	_tmp5_ = self->priv->_cut;
#line 59 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp5_, "activate", (GCallback) _node_menu_cut_gtk_menu_item_activate, self, 0);
#line 60 "../src/NodeMenu.vala"
	_tmp6_ = self->priv->_cut;
#line 60 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp6_, (guint) 'x', GDK_CONTROL_MASK);
#line 62 "../src/NodeMenu.vala"
	_tmp7_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Paste"));
#line 62 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp7_);
#line 62 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_paste);
#line 62 "../src/NodeMenu.vala"
	self->priv->_paste = _tmp7_;
#line 63 "../src/NodeMenu.vala"
	_tmp8_ = self->priv->_paste;
#line 63 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp8_, "activate", (GCallback) _node_menu_paste_gtk_menu_item_activate, self, 0);
#line 64 "../src/NodeMenu.vala"
	_tmp9_ = self->priv->_paste;
#line 64 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp9_, (guint) 'v', GDK_CONTROL_MASK);
#line 66 "../src/NodeMenu.vala"
	_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Delete"));
#line 66 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp10_);
#line 66 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_delete);
#line 66 "../src/NodeMenu.vala"
	self->priv->_delete = _tmp10_;
#line 67 "../src/NodeMenu.vala"
	_tmp11_ = self->priv->_delete;
#line 67 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp11_, "activate", (GCallback) _node_menu_delete_node_gtk_menu_item_activate, self, 0);
#line 68 "../src/NodeMenu.vala"
	_tmp12_ = self->priv->_delete;
#line 68 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp12_, (guint) 65535, 0);
#line 70 "../src/NodeMenu.vala"
	_tmp13_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Edit…"));
#line 70 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp13_);
#line 70 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_edit);
#line 70 "../src/NodeMenu.vala"
	self->priv->_edit = _tmp13_;
#line 71 "../src/NodeMenu.vala"
	_tmp14_ = self->priv->_edit;
#line 71 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp14_, "activate", (GCallback) _node_menu_edit_node_gtk_menu_item_activate, self, 0);
#line 72 "../src/NodeMenu.vala"
	_tmp15_ = self->priv->_edit;
#line 72 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp15_, (guint) 'e', 0);
#line 74 "../src/NodeMenu.vala"
	_tmp16_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Add Task"));
#line 74 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp16_);
#line 74 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_task);
#line 74 "../src/NodeMenu.vala"
	self->priv->_task = _tmp16_;
#line 75 "../src/NodeMenu.vala"
	_tmp17_ = self->priv->_task;
#line 75 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp17_, "activate", (GCallback) _node_menu_change_task_gtk_menu_item_activate, self, 0);
#line 77 "../src/NodeMenu.vala"
	_tmp18_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Add Note"));
#line 77 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp18_);
#line 77 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_note);
#line 77 "../src/NodeMenu.vala"
	self->priv->_note = _tmp18_;
#line 78 "../src/NodeMenu.vala"
	_tmp19_ = self->priv->_note;
#line 78 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp19_, "activate", (GCallback) _node_menu_change_note_gtk_menu_item_activate, self, 0);
#line 80 "../src/NodeMenu.vala"
	_tmp20_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Add Image"));
#line 80 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp20_);
#line 80 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_image);
#line 80 "../src/NodeMenu.vala"
	self->priv->_image = _tmp20_;
#line 81 "../src/NodeMenu.vala"
	_tmp21_ = self->priv->_image;
#line 81 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp21_, "activate", (GCallback) _node_menu_change_image_gtk_menu_item_activate, self, 0);
#line 83 "../src/NodeMenu.vala"
	_tmp22_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Add Connection"));
#line 83 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp22_);
#line 83 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_conn);
#line 83 "../src/NodeMenu.vala"
	self->priv->_conn = _tmp22_;
#line 84 "../src/NodeMenu.vala"
	_tmp23_ = self->priv->_conn;
#line 84 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp23_, "activate", (GCallback) _node_menu_add_connection_gtk_menu_item_activate, self, 0);
#line 85 "../src/NodeMenu.vala"
	_tmp24_ = self->priv->_conn;
#line 85 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp24_, (guint) 'x', 0);
#line 87 "../src/NodeMenu.vala"
	_tmp25_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Fold Children"));
#line 87 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp25_);
#line 87 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_fold);
#line 87 "../src/NodeMenu.vala"
	self->priv->_fold = _tmp25_;
#line 88 "../src/NodeMenu.vala"
	_tmp26_ = self->priv->_fold;
#line 88 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp26_, "activate", (GCallback) _node_menu_fold_node_gtk_menu_item_activate, self, 0);
#line 89 "../src/NodeMenu.vala"
	_tmp27_ = self->priv->_fold;
#line 89 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp27_, (guint) 'f', 0);
#line 91 "../src/NodeMenu.vala"
	_tmp28_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Detach"));
#line 91 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp28_);
#line 91 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_detach);
#line 91 "../src/NodeMenu.vala"
	self->priv->_detach = _tmp28_;
#line 92 "../src/NodeMenu.vala"
	_tmp29_ = self->priv->_detach;
#line 92 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp29_, "activate", (GCallback) _node_menu_detach_node_gtk_menu_item_activate, self, 0);
#line 94 "../src/NodeMenu.vala"
	_tmp30_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Add Root Node"));
#line 94 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp30_);
#line 94 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_root);
#line 94 "../src/NodeMenu.vala"
	self->priv->_root = _tmp30_;
#line 95 "../src/NodeMenu.vala"
	_tmp31_ = self->priv->_root;
#line 95 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp31_, "activate", (GCallback) _node_menu_add_root_node_gtk_menu_item_activate, self, 0);
#line 97 "../src/NodeMenu.vala"
	_tmp32_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Add Child Node"));
#line 97 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp32_);
#line 97 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_child);
#line 97 "../src/NodeMenu.vala"
	self->priv->_child = _tmp32_;
#line 98 "../src/NodeMenu.vala"
	_tmp33_ = self->priv->_child;
#line 98 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp33_, "activate", (GCallback) _node_menu_add_child_node_gtk_menu_item_activate, self, 0);
#line 99 "../src/NodeMenu.vala"
	_tmp34_ = self->priv->_child;
#line 99 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp34_, (guint) 65289, 0);
#line 101 "../src/NodeMenu.vala"
	_tmp35_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Add Sibling Node"));
#line 101 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp35_);
#line 101 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_sibling);
#line 101 "../src/NodeMenu.vala"
	self->priv->_sibling = _tmp35_;
#line 102 "../src/NodeMenu.vala"
	_tmp36_ = self->priv->_sibling;
#line 102 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp36_, "activate", (GCallback) _node_menu_add_sibling_node_gtk_menu_item_activate, self, 0);
#line 103 "../src/NodeMenu.vala"
	_tmp37_ = self->priv->_sibling;
#line 103 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp37_, (guint) 65293, 0);
#line 105 "../src/NodeMenu.vala"
	_tmp38_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Select"));
#line 105 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp38_);
#line 105 "../src/NodeMenu.vala"
	selnode = _tmp38_;
#line 106 "../src/NodeMenu.vala"
	_tmp39_ = (GtkMenu*) gtk_menu_new ();
#line 106 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp39_);
#line 106 "../src/NodeMenu.vala"
	selmenu = _tmp39_;
#line 107 "../src/NodeMenu.vala"
	gtk_menu_item_set_submenu (selnode, selmenu);
#line 109 "../src/NodeMenu.vala"
	_tmp40_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Root Node"));
#line 109 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp40_);
#line 109 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selroot);
#line 109 "../src/NodeMenu.vala"
	self->priv->_selroot = _tmp40_;
#line 110 "../src/NodeMenu.vala"
	_tmp41_ = self->priv->_selroot;
#line 110 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp41_, "activate", (GCallback) _node_menu_select_root_node_gtk_menu_item_activate, self, 0);
#line 111 "../src/NodeMenu.vala"
	_tmp42_ = self->priv->_selroot;
#line 111 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp42_, (guint) 'm', 0);
#line 113 "../src/NodeMenu.vala"
	_tmp43_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Next Sibling Node"));
#line 113 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp43_);
#line 113 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selnext);
#line 113 "../src/NodeMenu.vala"
	self->priv->_selnext = _tmp43_;
#line 114 "../src/NodeMenu.vala"
	_tmp44_ = self->priv->_selnext;
#line 114 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp44_, "activate", (GCallback) _node_menu_select_next_sibling_node_gtk_menu_item_activate, self, 0);
#line 115 "../src/NodeMenu.vala"
	_tmp45_ = self->priv->_selnext;
#line 115 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp45_, (guint) 'n', 0);
#line 117 "../src/NodeMenu.vala"
	_tmp46_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Previous Sibling Node"));
#line 117 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp46_);
#line 117 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selprev);
#line 117 "../src/NodeMenu.vala"
	self->priv->_selprev = _tmp46_;
#line 118 "../src/NodeMenu.vala"
	_tmp47_ = self->priv->_selprev;
#line 118 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp47_, "activate", (GCallback) _node_menu_select_previous_sibling_node_gtk_menu_item_activate, self, 0);
#line 119 "../src/NodeMenu.vala"
	_tmp48_ = self->priv->_selprev;
#line 119 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp48_, (guint) 'p', 0);
#line 121 "../src/NodeMenu.vala"
	_tmp49_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Child Node"));
#line 121 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp49_);
#line 121 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selchild);
#line 121 "../src/NodeMenu.vala"
	self->priv->_selchild = _tmp49_;
#line 122 "../src/NodeMenu.vala"
	_tmp50_ = self->priv->_selchild;
#line 122 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp50_, "activate", (GCallback) _node_menu_select_child_node_gtk_menu_item_activate, self, 0);
#line 123 "../src/NodeMenu.vala"
	_tmp51_ = self->priv->_selchild;
#line 123 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp51_, (guint) 'c', 0);
#line 125 "../src/NodeMenu.vala"
	_tmp52_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Parent Node"));
#line 125 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp52_);
#line 125 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selparent);
#line 125 "../src/NodeMenu.vala"
	self->priv->_selparent = _tmp52_;
#line 126 "../src/NodeMenu.vala"
	_tmp53_ = self->priv->_selparent;
#line 126 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp53_, "activate", (GCallback) _node_menu_select_parent_node_gtk_menu_item_activate, self, 0);
#line 127 "../src/NodeMenu.vala"
	_tmp54_ = self->priv->_selparent;
#line 127 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp54_, (guint) 'a', 0);
#line 129 "../src/NodeMenu.vala"
	_tmp55_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Connection"));
#line 129 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp55_);
#line 129 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selconn);
#line 129 "../src/NodeMenu.vala"
	self->priv->_selconn = _tmp55_;
#line 130 "../src/NodeMenu.vala"
	_tmp56_ = self->priv->_selconn;
#line 130 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp56_, "activate", (GCallback) _node_menu_select_connection_gtk_menu_item_activate, self, 0);
#line 131 "../src/NodeMenu.vala"
	_tmp57_ = self->priv->_selconn;
#line 131 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp57_, (guint) 'X', GDK_SHIFT_MASK);
#line 133 "../src/NodeMenu.vala"
	_tmp58_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Center Current Node"));
#line 133 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp58_);
#line 133 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_center);
#line 133 "../src/NodeMenu.vala"
	self->priv->_center = _tmp58_;
#line 134 "../src/NodeMenu.vala"
	_tmp59_ = self->priv->_center;
#line 134 "../src/NodeMenu.vala"
	g_signal_connect_object (_tmp59_, "activate", (GCallback) _node_menu_center_current_node_gtk_menu_item_activate, self, 0);
#line 135 "../src/NodeMenu.vala"
	_tmp60_ = self->priv->_center;
#line 135 "../src/NodeMenu.vala"
	utils_add_accel_label (_tmp60_, (guint) 'C', GDK_SHIFT_MASK);
#line 138 "../src/NodeMenu.vala"
	_tmp61_ = self->priv->_copy;
#line 138 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp61_);
#line 139 "../src/NodeMenu.vala"
	_tmp62_ = self->priv->_cut;
#line 139 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp62_);
#line 140 "../src/NodeMenu.vala"
	_tmp63_ = self->priv->_paste;
#line 140 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp63_);
#line 141 "../src/NodeMenu.vala"
	_tmp64_ = self->priv->_delete;
#line 141 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp64_);
#line 142 "../src/NodeMenu.vala"
	_tmp65_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 142 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp65_);
#line 142 "../src/NodeMenu.vala"
	_tmp66_ = _tmp65_;
#line 142 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp66_);
#line 142 "../src/NodeMenu.vala"
	_g_object_unref0 (_tmp66_);
#line 143 "../src/NodeMenu.vala"
	_tmp67_ = self->priv->_edit;
#line 143 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp67_);
#line 144 "../src/NodeMenu.vala"
	_tmp68_ = self->priv->_task;
#line 144 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp68_);
#line 145 "../src/NodeMenu.vala"
	_tmp69_ = self->priv->_note;
#line 145 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp69_);
#line 146 "../src/NodeMenu.vala"
	_tmp70_ = self->priv->_image;
#line 146 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp70_);
#line 147 "../src/NodeMenu.vala"
	_tmp71_ = self->priv->_conn;
#line 147 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp71_);
#line 148 "../src/NodeMenu.vala"
	_tmp72_ = self->priv->_fold;
#line 148 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp72_);
#line 149 "../src/NodeMenu.vala"
	_tmp73_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 149 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp73_);
#line 149 "../src/NodeMenu.vala"
	_tmp74_ = _tmp73_;
#line 149 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp74_);
#line 149 "../src/NodeMenu.vala"
	_g_object_unref0 (_tmp74_);
#line 150 "../src/NodeMenu.vala"
	_tmp75_ = self->priv->_root;
#line 150 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp75_);
#line 151 "../src/NodeMenu.vala"
	_tmp76_ = self->priv->_child;
#line 151 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp76_);
#line 152 "../src/NodeMenu.vala"
	_tmp77_ = self->priv->_sibling;
#line 152 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp77_);
#line 153 "../src/NodeMenu.vala"
	_tmp78_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 153 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp78_);
#line 153 "../src/NodeMenu.vala"
	_tmp79_ = _tmp78_;
#line 153 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp79_);
#line 153 "../src/NodeMenu.vala"
	_g_object_unref0 (_tmp79_);
#line 154 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) selnode);
#line 155 "../src/NodeMenu.vala"
	_tmp80_ = self->priv->_center;
#line 155 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp80_);
#line 156 "../src/NodeMenu.vala"
	_tmp81_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 156 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp81_);
#line 156 "../src/NodeMenu.vala"
	_tmp82_ = _tmp81_;
#line 156 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp82_);
#line 156 "../src/NodeMenu.vala"
	_g_object_unref0 (_tmp82_);
#line 157 "../src/NodeMenu.vala"
	_tmp83_ = self->priv->_detach;
#line 157 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp83_);
#line 160 "../src/NodeMenu.vala"
	_tmp84_ = self->priv->_selroot;
#line 160 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp84_);
#line 161 "../src/NodeMenu.vala"
	_tmp85_ = self->priv->_selnext;
#line 161 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp85_);
#line 162 "../src/NodeMenu.vala"
	_tmp86_ = self->priv->_selprev;
#line 162 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp86_);
#line 163 "../src/NodeMenu.vala"
	_tmp87_ = self->priv->_selchild;
#line 163 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp87_);
#line 164 "../src/NodeMenu.vala"
	_tmp88_ = self->priv->_selparent;
#line 164 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp88_);
#line 165 "../src/NodeMenu.vala"
	_tmp89_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 165 "../src/NodeMenu.vala"
	g_object_ref_sink (_tmp89_);
#line 165 "../src/NodeMenu.vala"
	_tmp90_ = _tmp89_;
#line 165 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp90_);
#line 165 "../src/NodeMenu.vala"
	_g_object_unref0 (_tmp90_);
#line 166 "../src/NodeMenu.vala"
	_tmp91_ = self->priv->_selconn;
#line 166 "../src/NodeMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp91_);
#line 169 "../src/NodeMenu.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 172 "../src/NodeMenu.vala"
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) _node_menu_on_popup_gtk_widget_show, self, 0);
#line 50 "../src/NodeMenu.vala"
	_g_object_unref0 (selmenu);
#line 50 "../src/NodeMenu.vala"
	_g_object_unref0 (selnode);
#line 50 "../src/NodeMenu.vala"
	return self;
#line 1079 "NodeMenu.c"
}

NodeMenu*
node_menu_new (DrawArea* da,
               GtkAccelGroup* accel_group)
{
#line 50 "../src/NodeMenu.vala"
	return node_menu_construct (TYPE_NODE_MENU, da, accel_group);
#line 1088 "NodeMenu.c"
}

static gboolean
node_menu_node_is_task (NodeMenu* self)
{
	gboolean result = FALSE;
	Node* current = NULL;
	DrawArea* _tmp0_;
	Node* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Node* _tmp3_;
#line 177 "../src/NodeMenu.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 178 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 178 "../src/NodeMenu.vala"
	_tmp1_ = draw_area_get_current_node (_tmp0_);
#line 178 "../src/NodeMenu.vala"
	current = _tmp1_;
#line 179 "../src/NodeMenu.vala"
	_tmp3_ = current;
#line 179 "../src/NodeMenu.vala"
	if (_tmp3_ != NULL) {
#line 1112 "NodeMenu.c"
		Node* _tmp4_;
#line 179 "../src/NodeMenu.vala"
		_tmp4_ = current;
#line 179 "../src/NodeMenu.vala"
		_tmp2_ = node_task_enabled (_tmp4_);
#line 1118 "NodeMenu.c"
	} else {
#line 179 "../src/NodeMenu.vala"
		_tmp2_ = FALSE;
#line 1122 "NodeMenu.c"
	}
#line 179 "../src/NodeMenu.vala"
	result = _tmp2_;
#line 179 "../src/NodeMenu.vala"
	_g_object_unref0 (current);
#line 179 "../src/NodeMenu.vala"
	return result;
#line 1130 "NodeMenu.c"
}

static gboolean
node_menu_node_has_note (NodeMenu* self)
{
	gboolean result = FALSE;
	Node* current = NULL;
	DrawArea* _tmp0_;
	Node* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Node* _tmp3_;
#line 183 "../src/NodeMenu.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 184 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 184 "../src/NodeMenu.vala"
	_tmp1_ = draw_area_get_current_node (_tmp0_);
#line 184 "../src/NodeMenu.vala"
	current = _tmp1_;
#line 185 "../src/NodeMenu.vala"
	_tmp3_ = current;
#line 185 "../src/NodeMenu.vala"
	if (_tmp3_ != NULL) {
#line 1154 "NodeMenu.c"
		Node* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 185 "../src/NodeMenu.vala"
		_tmp4_ = current;
#line 185 "../src/NodeMenu.vala"
		_tmp5_ = node_get_note (_tmp4_);
#line 185 "../src/NodeMenu.vala"
		_tmp6_ = _tmp5_;
#line 185 "../src/NodeMenu.vala"
		_tmp2_ = g_strcmp0 (_tmp6_, "") != 0;
#line 1166 "NodeMenu.c"
	} else {
#line 185 "../src/NodeMenu.vala"
		_tmp2_ = FALSE;
#line 1170 "NodeMenu.c"
	}
#line 185 "../src/NodeMenu.vala"
	result = _tmp2_;
#line 185 "../src/NodeMenu.vala"
	_g_object_unref0 (current);
#line 185 "../src/NodeMenu.vala"
	return result;
#line 1178 "NodeMenu.c"
}

static gboolean
node_menu_node_has_image (NodeMenu* self)
{
	gboolean result = FALSE;
	Node* current = NULL;
	DrawArea* _tmp0_;
	Node* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Node* _tmp3_;
#line 189 "../src/NodeMenu.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 190 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 190 "../src/NodeMenu.vala"
	_tmp1_ = draw_area_get_current_node (_tmp0_);
#line 190 "../src/NodeMenu.vala"
	current = _tmp1_;
#line 191 "../src/NodeMenu.vala"
	_tmp3_ = current;
#line 191 "../src/NodeMenu.vala"
	if (_tmp3_ != NULL) {
#line 1202 "NodeMenu.c"
		Node* _tmp4_;
		NodeImage* _tmp5_;
		NodeImage* _tmp6_;
#line 191 "../src/NodeMenu.vala"
		_tmp4_ = current;
#line 191 "../src/NodeMenu.vala"
		_tmp5_ = node_get_image (_tmp4_);
#line 191 "../src/NodeMenu.vala"
		_tmp6_ = _tmp5_;
#line 191 "../src/NodeMenu.vala"
		_tmp2_ = _tmp6_ != NULL;
#line 1214 "NodeMenu.c"
	} else {
#line 191 "../src/NodeMenu.vala"
		_tmp2_ = FALSE;
#line 1218 "NodeMenu.c"
	}
#line 191 "../src/NodeMenu.vala"
	result = _tmp2_;
#line 191 "../src/NodeMenu.vala"
	_g_object_unref0 (current);
#line 191 "../src/NodeMenu.vala"
	return result;
#line 1226 "NodeMenu.c"
}

static gboolean
node_menu_node_foldable (NodeMenu* self)
{
	gboolean result = FALSE;
	Node* current = NULL;
	DrawArea* _tmp0_;
	Node* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Node* _tmp3_;
#line 195 "../src/NodeMenu.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 196 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 196 "../src/NodeMenu.vala"
	_tmp1_ = draw_area_get_current_node (_tmp0_);
#line 196 "../src/NodeMenu.vala"
	current = _tmp1_;
#line 197 "../src/NodeMenu.vala"
	_tmp3_ = current;
#line 197 "../src/NodeMenu.vala"
	if (_tmp3_ != NULL) {
#line 1250 "NodeMenu.c"
		Node* _tmp4_;
#line 197 "../src/NodeMenu.vala"
		_tmp4_ = current;
#line 197 "../src/NodeMenu.vala"
		_tmp2_ = !node_is_leaf (_tmp4_);
#line 1256 "NodeMenu.c"
	} else {
#line 197 "../src/NodeMenu.vala"
		_tmp2_ = FALSE;
#line 1260 "NodeMenu.c"
	}
#line 197 "../src/NodeMenu.vala"
	result = _tmp2_;
#line 197 "../src/NodeMenu.vala"
	_g_object_unref0 (current);
#line 197 "../src/NodeMenu.vala"
	return result;
#line 1268 "NodeMenu.c"
}

static gboolean
node_menu_node_is_folded (NodeMenu* self)
{
	gboolean result = FALSE;
	Node* current = NULL;
	DrawArea* _tmp0_;
	Node* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Node* _tmp3_;
#line 204 "../src/NodeMenu.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 205 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 205 "../src/NodeMenu.vala"
	_tmp1_ = draw_area_get_current_node (_tmp0_);
#line 205 "../src/NodeMenu.vala"
	current = _tmp1_;
#line 206 "../src/NodeMenu.vala"
	_tmp3_ = current;
#line 206 "../src/NodeMenu.vala"
	if (_tmp3_ != NULL) {
#line 1292 "NodeMenu.c"
		Node* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 206 "../src/NodeMenu.vala"
		_tmp4_ = current;
#line 206 "../src/NodeMenu.vala"
		_tmp5_ = node_get_folded (_tmp4_);
#line 206 "../src/NodeMenu.vala"
		_tmp6_ = _tmp5_;
#line 206 "../src/NodeMenu.vala"
		_tmp2_ = _tmp6_;
#line 1304 "NodeMenu.c"
	} else {
#line 206 "../src/NodeMenu.vala"
		_tmp2_ = FALSE;
#line 1308 "NodeMenu.c"
	}
#line 206 "../src/NodeMenu.vala"
	result = _tmp2_;
#line 206 "../src/NodeMenu.vala"
	_g_object_unref0 (current);
#line 206 "../src/NodeMenu.vala"
	return result;
#line 1316 "NodeMenu.c"
}

static void
node_menu_on_popup (NodeMenu* self)
{
	GtkMenuItem* _tmp0_;
	DrawArea* _tmp1_;
	GtkMenuItem* _tmp2_;
	DrawArea* _tmp3_;
	Connections* _tmp4_;
	Connections* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	DrawArea* _tmp10_;
	GtkMenuItem* _tmp11_;
	DrawArea* _tmp12_;
	GtkMenuItem* _tmp13_;
	DrawArea* _tmp14_;
	GtkMenuItem* _tmp15_;
	DrawArea* _tmp16_;
	GtkMenuItem* _tmp17_;
	DrawArea* _tmp18_;
	GtkMenuItem* _tmp19_;
	DrawArea* _tmp20_;
	const gchar* _tmp21_ = NULL;
	GtkMenuItem* _tmp22_;
	const gchar* _tmp23_ = NULL;
	GtkMenuItem* _tmp24_;
	const gchar* _tmp25_ = NULL;
	GtkMenuItem* _tmp26_;
	const gchar* _tmp27_ = NULL;
	GtkMenuItem* _tmp28_;
#line 210 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 213 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_paste;
#line 213 "../src/NodeMenu.vala"
	_tmp1_ = self->priv->_da;
#line 213 "../src/NodeMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, draw_area_node_pasteable (_tmp1_));
#line 214 "../src/NodeMenu.vala"
	_tmp2_ = self->priv->_conn;
#line 214 "../src/NodeMenu.vala"
	_tmp3_ = self->priv->_da;
#line 214 "../src/NodeMenu.vala"
	_tmp4_ = draw_area_get_connections (_tmp3_);
#line 214 "../src/NodeMenu.vala"
	_tmp5_ = _tmp4_;
#line 214 "../src/NodeMenu.vala"
	_tmp6_ = connections_get_hide (_tmp5_);
#line 214 "../src/NodeMenu.vala"
	_tmp7_ = _tmp6_;
#line 214 "../src/NodeMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, !_tmp7_);
#line 214 "../src/NodeMenu.vala"
	_connections_unref0 (_tmp5_);
#line 215 "../src/NodeMenu.vala"
	_tmp8_ = self->priv->_fold;
#line 215 "../src/NodeMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, node_menu_node_foldable (self));
#line 216 "../src/NodeMenu.vala"
	_tmp9_ = self->priv->_detach;
#line 216 "../src/NodeMenu.vala"
	_tmp10_ = self->priv->_da;
#line 216 "../src/NodeMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, draw_area_detachable (_tmp10_));
#line 217 "../src/NodeMenu.vala"
	_tmp11_ = self->priv->_selroot;
#line 217 "../src/NodeMenu.vala"
	_tmp12_ = self->priv->_da;
#line 217 "../src/NodeMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, draw_area_root_selectable (_tmp12_));
#line 218 "../src/NodeMenu.vala"
	_tmp13_ = self->priv->_selnext;
#line 218 "../src/NodeMenu.vala"
	_tmp14_ = self->priv->_da;
#line 218 "../src/NodeMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, draw_area_sibling_selectable (_tmp14_));
#line 219 "../src/NodeMenu.vala"
	_tmp15_ = self->priv->_selprev;
#line 219 "../src/NodeMenu.vala"
	_tmp16_ = self->priv->_da;
#line 219 "../src/NodeMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, draw_area_sibling_selectable (_tmp16_));
#line 220 "../src/NodeMenu.vala"
	_tmp17_ = self->priv->_selchild;
#line 220 "../src/NodeMenu.vala"
	_tmp18_ = self->priv->_da;
#line 220 "../src/NodeMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, draw_area_child_selectable (_tmp18_));
#line 221 "../src/NodeMenu.vala"
	_tmp19_ = self->priv->_selparent;
#line 221 "../src/NodeMenu.vala"
	_tmp20_ = self->priv->_da;
#line 221 "../src/NodeMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, draw_area_parent_selectable (_tmp20_));
#line 224 "../src/NodeMenu.vala"
	if (node_menu_node_is_task (self)) {
#line 224 "../src/NodeMenu.vala"
		_tmp21_ = _ ("Remove Task");
#line 1419 "NodeMenu.c"
	} else {
#line 224 "../src/NodeMenu.vala"
		_tmp21_ = _ ("Add Task");
#line 1423 "NodeMenu.c"
	}
#line 224 "../src/NodeMenu.vala"
	_tmp22_ = self->priv->_task;
#line 224 "../src/NodeMenu.vala"
	gtk_menu_item_set_label (_tmp22_, _tmp21_);
#line 225 "../src/NodeMenu.vala"
	if (node_menu_node_has_note (self)) {
#line 225 "../src/NodeMenu.vala"
		_tmp23_ = _ ("Remove Note");
#line 1433 "NodeMenu.c"
	} else {
#line 225 "../src/NodeMenu.vala"
		_tmp23_ = _ ("Add Note");
#line 1437 "NodeMenu.c"
	}
#line 225 "../src/NodeMenu.vala"
	_tmp24_ = self->priv->_note;
#line 225 "../src/NodeMenu.vala"
	gtk_menu_item_set_label (_tmp24_, _tmp23_);
#line 226 "../src/NodeMenu.vala"
	if (node_menu_node_has_image (self)) {
#line 226 "../src/NodeMenu.vala"
		_tmp25_ = _ ("Remove Image");
#line 1447 "NodeMenu.c"
	} else {
#line 226 "../src/NodeMenu.vala"
		_tmp25_ = _ ("Add Image");
#line 1451 "NodeMenu.c"
	}
#line 226 "../src/NodeMenu.vala"
	_tmp26_ = self->priv->_image;
#line 226 "../src/NodeMenu.vala"
	gtk_menu_item_set_label (_tmp26_, _tmp25_);
#line 227 "../src/NodeMenu.vala"
	if (node_menu_node_is_folded (self)) {
#line 227 "../src/NodeMenu.vala"
		_tmp27_ = _ ("Unfold Children");
#line 1461 "NodeMenu.c"
	} else {
#line 227 "../src/NodeMenu.vala"
		_tmp27_ = _ ("Fold Children");
#line 1465 "NodeMenu.c"
	}
#line 227 "../src/NodeMenu.vala"
	_tmp28_ = self->priv->_fold;
#line 227 "../src/NodeMenu.vala"
	gtk_menu_item_set_label (_tmp28_, _tmp27_);
#line 1471 "NodeMenu.c"
}

static void
node_menu_copy (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 232 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 233 "../src/NodeMenu.vala"
	draw_area_do_copy (_tmp0_);
#line 1484 "NodeMenu.c"
}

static void
node_menu_cut (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 237 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 238 "../src/NodeMenu.vala"
	draw_area_do_cut (_tmp0_);
#line 1497 "NodeMenu.c"
}

static void
node_menu_paste (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 246 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 247 "../src/NodeMenu.vala"
	draw_area_do_paste (_tmp0_);
#line 1510 "NodeMenu.c"
}

static void
node_menu_delete_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 251 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 252 "../src/NodeMenu.vala"
	draw_area_delete_node (_tmp0_);
#line 1523 "NodeMenu.c"
}

static void
node_menu_edit_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 256 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 257 "../src/NodeMenu.vala"
	g_signal_emit_by_name (_tmp0_, "show-properties", "current", FALSE);
#line 1536 "NodeMenu.c"
}

static void
node_menu_change_task (NodeMenu* self)
{
	DrawArea* _tmp2_;
#line 261 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/NodeMenu.vala"
	if (node_menu_node_is_task (self)) {
#line 1547 "NodeMenu.c"
		DrawArea* _tmp0_;
#line 263 "../src/NodeMenu.vala"
		_tmp0_ = self->priv->_da;
#line 263 "../src/NodeMenu.vala"
		draw_area_change_current_task (_tmp0_, FALSE, FALSE);
#line 1553 "NodeMenu.c"
	} else {
		DrawArea* _tmp1_;
#line 265 "../src/NodeMenu.vala"
		_tmp1_ = self->priv->_da;
#line 265 "../src/NodeMenu.vala"
		draw_area_change_current_task (_tmp1_, TRUE, FALSE);
#line 1560 "NodeMenu.c"
	}
#line 267 "../src/NodeMenu.vala"
	_tmp2_ = self->priv->_da;
#line 267 "../src/NodeMenu.vala"
	g_signal_emit_by_name (_tmp2_, "current-changed");
#line 1566 "NodeMenu.c"
}

static void
node_menu_change_note (NodeMenu* self)
{
	DrawArea* _tmp2_;
#line 271 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/NodeMenu.vala"
	if (node_menu_node_has_note (self)) {
#line 1577 "NodeMenu.c"
		DrawArea* _tmp0_;
#line 273 "../src/NodeMenu.vala"
		_tmp0_ = self->priv->_da;
#line 273 "../src/NodeMenu.vala"
		draw_area_change_current_node_note (_tmp0_, "");
#line 1583 "NodeMenu.c"
	} else {
		DrawArea* _tmp1_;
#line 275 "../src/NodeMenu.vala"
		_tmp1_ = self->priv->_da;
#line 275 "../src/NodeMenu.vala"
		g_signal_emit_by_name (_tmp1_, "show-properties", "current", TRUE);
#line 1590 "NodeMenu.c"
	}
#line 277 "../src/NodeMenu.vala"
	_tmp2_ = self->priv->_da;
#line 277 "../src/NodeMenu.vala"
	g_signal_emit_by_name (_tmp2_, "current-changed");
#line 1596 "NodeMenu.c"
}

static void
node_menu_change_image (NodeMenu* self)
{
	DrawArea* _tmp2_;
#line 281 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 282 "../src/NodeMenu.vala"
	if (node_menu_node_has_image (self)) {
#line 1607 "NodeMenu.c"
		DrawArea* _tmp0_;
#line 283 "../src/NodeMenu.vala"
		_tmp0_ = self->priv->_da;
#line 283 "../src/NodeMenu.vala"
		draw_area_delete_current_image (_tmp0_);
#line 1613 "NodeMenu.c"
	} else {
		DrawArea* _tmp1_;
#line 285 "../src/NodeMenu.vala"
		_tmp1_ = self->priv->_da;
#line 285 "../src/NodeMenu.vala"
		draw_area_add_current_image (_tmp1_);
#line 1620 "NodeMenu.c"
	}
#line 287 "../src/NodeMenu.vala"
	_tmp2_ = self->priv->_da;
#line 287 "../src/NodeMenu.vala"
	g_signal_emit_by_name (_tmp2_, "current-changed");
#line 1626 "NodeMenu.c"
}

static void
node_menu_add_connection (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 291 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 292 "../src/NodeMenu.vala"
	draw_area_start_connection (_tmp0_, FALSE);
#line 1639 "NodeMenu.c"
}

static void
node_menu_fold_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
	DrawArea* _tmp1_;
#line 296 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 297 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 297 "../src/NodeMenu.vala"
	draw_area_change_current_fold (_tmp0_, !node_menu_node_is_folded (self));
#line 298 "../src/NodeMenu.vala"
	_tmp1_ = self->priv->_da;
#line 298 "../src/NodeMenu.vala"
	g_signal_emit_by_name (_tmp1_, "current-changed");
#line 1657 "NodeMenu.c"
}

static void
node_menu_add_root_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 302 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 303 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 303 "../src/NodeMenu.vala"
	draw_area_add_root_node (_tmp0_);
#line 1670 "NodeMenu.c"
}

static void
node_menu_add_child_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 307 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 308 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 308 "../src/NodeMenu.vala"
	draw_area_add_child_node (_tmp0_);
#line 1683 "NodeMenu.c"
}

static void
node_menu_add_sibling_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 312 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 313 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 313 "../src/NodeMenu.vala"
	draw_area_add_sibling_node (_tmp0_);
#line 1696 "NodeMenu.c"
}

static void
node_menu_detach_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 317 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 318 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 318 "../src/NodeMenu.vala"
	draw_area_detach (_tmp0_);
#line 1709 "NodeMenu.c"
}

static void
node_menu_select_root_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 322 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 323 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 323 "../src/NodeMenu.vala"
	draw_area_select_root_node (_tmp0_);
#line 1722 "NodeMenu.c"
}

static void
node_menu_select_next_sibling_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 327 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 328 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 328 "../src/NodeMenu.vala"
	draw_area_select_sibling_node (_tmp0_, 1);
#line 1735 "NodeMenu.c"
}

static void
node_menu_select_previous_sibling_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 332 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 333 "../src/NodeMenu.vala"
	draw_area_select_sibling_node (_tmp0_, -1);
#line 1748 "NodeMenu.c"
}

static void
node_menu_select_child_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 337 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 338 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 338 "../src/NodeMenu.vala"
	draw_area_select_child_node (_tmp0_);
#line 1761 "NodeMenu.c"
}

static void
node_menu_select_parent_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 342 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 343 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 343 "../src/NodeMenu.vala"
	draw_area_select_parent_node (_tmp0_);
#line 1774 "NodeMenu.c"
}

static void
node_menu_select_connection (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 347 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 348 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 348 "../src/NodeMenu.vala"
	draw_area_select_attached_connection (_tmp0_);
#line 1787 "NodeMenu.c"
}

static void
node_menu_center_current_node (NodeMenu* self)
{
	DrawArea* _tmp0_;
#line 352 "../src/NodeMenu.vala"
	g_return_if_fail (self != NULL);
#line 353 "../src/NodeMenu.vala"
	_tmp0_ = self->priv->_da;
#line 353 "../src/NodeMenu.vala"
	draw_area_center_current_node (_tmp0_);
#line 1800 "NodeMenu.c"
}

static void
node_menu_class_init (NodeMenuClass * klass,
                      gpointer klass_data)
{
#line 24 "../src/NodeMenu.vala"
	node_menu_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/NodeMenu.vala"
	g_type_class_adjust_private_offset (klass, &NodeMenu_private_offset);
#line 24 "../src/NodeMenu.vala"
	G_OBJECT_CLASS (klass)->finalize = node_menu_finalize;
#line 1813 "NodeMenu.c"
}

static void
node_menu_instance_init (NodeMenu * self,
                         gpointer klass)
{
#line 24 "../src/NodeMenu.vala"
	self->priv = node_menu_get_instance_private (self);
#line 1822 "NodeMenu.c"
}

static void
node_menu_finalize (GObject * obj)
{
	NodeMenu * self;
#line 24 "../src/NodeMenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NODE_MENU, NodeMenu);
#line 26 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_da);
#line 27 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_copy);
#line 28 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_cut);
#line 29 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_paste);
#line 30 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_delete);
#line 31 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_edit);
#line 32 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_task);
#line 33 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_note);
#line 34 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_image);
#line 35 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_conn);
#line 36 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_fold);
#line 37 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_detach);
#line 38 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_root);
#line 39 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_child);
#line 40 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_sibling);
#line 41 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selroot);
#line 42 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selnext);
#line 43 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selprev);
#line 44 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selchild);
#line 45 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selparent);
#line 46 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_selconn);
#line 47 "../src/NodeMenu.vala"
	_g_object_unref0 (self->priv->_center);
#line 24 "../src/NodeMenu.vala"
	G_OBJECT_CLASS (node_menu_parent_class)->finalize (obj);
#line 1877 "NodeMenu.c"
}

GType
node_menu_get_type (void)
{
	static volatile gsize node_menu_type_id__volatile = 0;
	if (g_once_init_enter (&node_menu_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NodeMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) node_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NodeMenu), 0, (GInstanceInitFunc) node_menu_instance_init, NULL };
		GType node_menu_type_id;
		node_menu_type_id = g_type_register_static (gtk_menu_get_type (), "NodeMenu", &g_define_type_info, 0);
		NodeMenu_private_offset = g_type_add_instance_private (node_menu_type_id, sizeof (NodeMenuPrivate));
		g_once_init_leave (&node_menu_type_id__volatile, node_menu_type_id);
	}
	return node_menu_type_id__volatile;
}

